/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLSOURCEVIDEOFILE_H__
#define __TLSOURCEVIDEOFILE_H__



#include "tlVision.h"
#include "tlSource.h"

// DirectX headers
#ifndef __TLDIRECTXH__
#define __TLDIRECTXH__
#include <atlbase.h>
#include <qedit.h>
#include <streams.h>
#include <dshow.h>

#endif



// interface
class tlSourceVideoFile : tlSource
{
private:
  char *filename;

  IGraphBuilder  *pGraph;
  IMediaControl  *pControl;
  IMediaEvent    *pEvent;
  ISampleGrabber *pGrabber;
  IMediaSeeking  *pSeek;
  char           *buffer;
  long           evCode;
  long           size;
  LONGLONG       length;
  LONGLONG       current;
  

public:
  tlSourceVideoFile  (char *filename);

  int getLength () { return (int)length;  };
  int getIndex  () { return (int)current; };

  int open     (char *filename);
  int close    ();
  int setFrame (int frame);

  virtual int grab        (tlImage *image);
  virtual int grab        (tlImage *image, tlRect *rect);
  virtual int grabQueued  (tlImage *image);
  virtual int grabQueued  (tlImage *image, tlRect *rect);
};

#endif

